;01: Este programa asigna valores a registros y variables 
;02: Es muy importante fijarse en la medida de los registros y
;03: de las variables utilizadas.
;04: Si no se hace correctamente puede causar asignaciones incorrectas y
;05: es la causa de muchos errores al desarrollar los programas.
                              ;06:
                              ;07: Definimos constantes en ensamblador.
  valueBinary  equ 00111100b  ;08: Valor binario.     Base 2
  valueOctal   equ      074o  ;09: Valor octal.       Base 8
  valueDecimal equ       60   ;10: Valor decimal.     Base 10
  valueHexadecimal equ   3Ch  ;11: Valor hexadecimal. Base 16
                              ;12: 
section .data                 ;13: Empieza la sección de datos
                              ;14:
                              ;15: Definimos variables en ensamblador.
  varDB db 0x01               ;16: Variable de tipo BYTE  (1 byte)
  varDW dw 0x0123             ;17: Variable de tipo WORD  (2 bytes)
  varDD dd 0x01023567         ;18: Variable de tipo DWORD (4 bytes)
  varDQ dq 0x0123456789ABCDEF ;19: Variable de tipo DWORD (4 bytes)
                              ;20: 
section .text                 ;21: Finaliza la sección de datos y empieza la sección de código.
                              ;22:  
  global dataTypes            ;23: Hacemos visible la subrutina de ensamblador 
                              ;24: que queremos llamar desde C.
  extern varChar, varShortInt ;25: Variables definidas en C que queremos 
  extern varInt , varLongInt  ;26: acceder desde ensamblador.
                              ;27: 
  dataTypes:                  ;28: Etiqueta que hacemos visible para poder llamar 
                              ;29: a esta subrutina desde C.
    mov rax, 0                ;30: Ejemplos de instrucciones de transferencia.
    mov rax, [varLongInt]     ;31: 
    mov eax, [varInt]         ;32:
    mov ax,  [varShortInt]    ;33:
    mov al,  [varChar]        ;34:
                              ;35:
    mov [varLongInt], rax     ;36
                              ;37:
    mov al,  [varDB]          ;38:
    mov ax,  [varDW]          ;39:
    mov eax, [varDD]          ;40:
    mov rax, [varDQ]          ;41:
                              ;42:
    mov [varChar], rax        ;43: 
                              ;44:
    mov rax, [varLongInt]     ;45:
    mov rbx, varLongInt       ;46:
    mov rcx, [0x601050]       ;47:
                              ;48:
    mov eax, [varChar+2]      ;49:
                              ;50:
    mov al, valueBinary       ;51:
    mov al, valueOctal        ;52:
    mov al, valueDecimal      ;53:
    mov al, valueHexadecimal  ;54:
                              ;55:
    ret                       ;56: Retornar el control al código C.
                              ;57:
