;01: Este programa realiza una división. dividendo/divisor
;02: pero en vez de hacer una división, se hacen restas iterativas.
;03: dividendo = divisor * cociente + residuo
;04: Ejemplo: Para dividir 14 / 4 , el programa hace:  
;05: 14 - 4 = 10; 10 - 4 = 6; 6 - 4 = 2;
;06: (restamos 3 veces divisor del dividendo). cociente=3 y residuo=2
                          ;07:
  constante  equ  14      ;08: Definimos una constante que utilizaremos en el programa.	
                          ;09: 
section .data             ;10: Empieza la sección de datos
                          ;11:
  dividendo dq constante  ;12: Declaramos el valor que queremos dividir,  
                          ;13: inicializado con el valor de una constante.
  divisor   dq 4          ;14: Declaramos el valor por el que queremos dividir, 
                          ;15: inicializado a 4
  cociente  dq 0          ;16: Declaramos la variable donde guardaremos el cociente
                          ;17: inicializado a 0.
  residuo   dq 0          ;18: Declaramos la variable donde guardaremos el residuo
                          ;19: inicializado a 0.
section .text             ;20: Finaliza la sección de datos y empieza la sección de código
  global main             ;21: Esta directiva es para hacer visible 
                          ;22: una etiqueta para el compilador de C.
  main:                   ;23: Por defecto el compilador de C reconoce cómo
                          ;24: punto de inicio del programa la etiqueta main
    mov rax, [dividendo]  ;25: Inicializamos el registro rax con el dividendo, es donde quedará 
                          ;26: el residuo de la división, iremos restando el divisor mientras 
    mov rcx, 0            ;27: rax sea mayor o igual que el divisor. A rcx guardaremos
                          ;28: el número de restas que hacemos, será el cociente de la división.
    bucle:                ;29: Etiqueta para marcar un punto del código, el inicio del bucle.
                          ;30:
      sub rax, [divisor]  ;31: Restamos el divisor de rax.
                          ;32:
      inc rcx             ;33: Contamos cuántas restas hacemos. Valor del cociente.
                          ;34:
      cmp rax, [divisor]  ;35: Miramos si rax es mayor o igual que el divisor.
      jge bucle           ;36: Si es mayor o igual continuamos iterando, ir a 'bucle'.
                          ;37: Si es menor, la división ha finalizado.
    mov [residuo], rax    ;38: Guardem en la variable de memòria 'residu'
                          ;39: el valor que tenemos a rax.
    mov [cociente], rcx   ;40: Guardamos en la variable de memoria 'cociente'
                          ;41: el valor que tenemos a rcx.
                          ;42:
                          ;43: Devuelve el control al terminal
                          ;44: del sistema operativo
  mov rax,1               ;45: Pone el valor 1 en el registro rax
                          ;46: para llamar a la función exit (sys_exit)
  mov rbx,0               ;47: Posa el valor 0 al registre rbx indica
                          ;48: el código de retorno (0 = sin errores)
  int 80h	          ;49: llamada al sistema operativo.
                          ;50:
