;01: Este programa realiza una división. dividendo/divisor
;02: pero en vez de hacer una división, se hacen restas iterativas.
;03: dividendo = divisor * cociente + residuo
;04: Ejemplo: Para dividir 14 / 4 , el programa hace:  
;05: 14 - 4 = 10; 10 - 4 = 6; 6 - 4 = 2;
;06: (restamos 3 veces divisor del dividendo). cociente=3 y residuo=2
                          ;07:
section .data             ;08: Empieza la sección de datos
                          ;09:
section .text             ;10: Finaliza la sección de datos y empieza la sección de código
                          ;11:
  global div2             ;12: Hacemos visible la subrutina de ensamblador que queremos llamar desde C. 
                          ;13: 
  extern dividendo, divisor, cociente, residuo ;14: Variables definidas en C que queremos acceder desde ensamblador.
                          ;15:
  div2:                   ;16: Etiqueta que hacemos visible para poder llamar 
                          ;17: esta subrutina desde C.
    mov rax, [dividendo]  ;18: Inicializamos el registro rax con el dividendo, es donde quedará 
                          ;19: el residuo de la división, iremos restando el divisor mientras 
    mov rcx, 0            ;20: rax sea mayor o igual que el divisor. A rcx guardaremos
                          ;21: el número de restas que hacemos, será el cociente de la división.
    bucle:                ;22: Etiqueta para marcar un punto del código, el inicio del bucle.
                          ;23:
      sub rax, [divisor]  ;24: Restamos el divisor de rax.
                          ;25:
      inc rcx             ;26: Contamos cuántas restas hacemos. Valor del cociente.
                          ;27:
      cmp rax, [divisor]  ;28: Miramos si rax es mayor o igual que el divisor.
      jge bucle           ;29: Si es mayor o igual continuamos iterando, ir a 'bucle'.
                          ;30: Si es menor, la división ha finalizado.
    mov [residuo], rax    ;31: Guardamos en la variable de memoria 'residuo'
                          ;32: el valor que tenemos a rax.
    mov [cociente], rcx   ;33: Guardamos en la variable de memoria 'cociente'
                          ;34: el valor que tenemos a rcx.
    ret                   ;35: Devuelve el control al código C.
                          ;36: 
